<?php

// Start the plugin
add_action('init', 'envatoaff_init');
function envatoaff_init(){

	// Get Options
	$envatoaff_enabled = get_option('ieaff_envatoaff_enabled');
	$envatoaff_content_level = get_option('ieaff_envatoaff_content');
	
	// Only continue if enabled
	if( $envatoaff_enabled == '1' ){

		// Filter Breakdown
		if( $envatoaff_content_level == 'all' ){
			
			add_filter('comment_author_link', 'envatoaff_create_ref');
			add_filter('comment_author_text', 'envatoaff_create_ref');
			add_filter('comment_author_text_rss', 'envatoaff_create_ref');
			add_filter('the_excerpt', 'envatoaff_create_ref');
			add_filter('the_excerpt_rss', 'envatoaff_create_ref');
			add_filter('the_content', 'envatoaff_create_ref');
			add_filter('the_content_rss', 'envatoaff_create_ref');
			add_filter('the_meta_key', 'envatoaff_create_ref');
			
		} else if( $envatoaff_content_level == 'meta' ){
	
			add_filter('the_excerpt', 'envatoaff_create_ref');
			add_filter('the_excerpt_rss', 'envatoaff_create_ref');
			add_filter('the_content', 'envatoaff_create_ref');
			add_filter('the_content_rss', 'envatoaff_create_ref');
			add_filter('the_meta_key', 'envatoaff_create_ref');
			
		} else if( $envatoaff_content_level == 'post' ){
			
			add_filter('the_content', 'envatoaff_create_ref');
			add_filter('the_content_rss', 'envatoaff_create_ref');
			add_filter('the_meta_key', 'envatoaff_create_ref');
			
		} // end content sort
		
	} // end if enabled

}

//	Generate Referal Links
function envatoaff_create_ref($content){
	
	// Get options
	$envatoaff_envato_name = get_option( 'plugin_prefix_text_field_id' );
	$market_url = get_option( 'ieaff_ir_market_url' );
	$encode_urls = get_option('ieaff_base64_encode');
	$redirect_url = get_option('ieaff_redirect_page');

	// Get redirect page slug
    $post = get_post($redirect_url); 
    $slug = $post->post_name;
		
	// Match URL and Replace With Username
    preg_match_all('/((http(s?):\/\/(www\.)?)|(www\.))(photodune|codecanyon|themeforest|activeden|audiojungle|videohive|graphicriver|3docean|elements.envato|marketplace\.tutsplus)\.([a-zA-Z0-9:\/=+_-]+)(\?[a-zA-Z0-9\?.&#;:\/=+_-]+)?/i', $content, $matches);
	
	// Handle each link seperate :)
	foreach( array_unique($matches[0]) as $key => $match ){
				
		$new_url = ''.$market_url.'?u=http'.$matches[3][$key].'://'.$matches[4][$key].$matches[5][$key].$matches[6][$key].'.'.$matches[7][$key];

		if( $encode_urls == '0' ){
					
		$content = str_replace($match, envatoaff_url_handle($new_url), $content);

		} else {

		$encode_url	= ''.home_url().'/'.$slug.'/?'.base64_encode($new_url);
		$content = str_replace($match, envatoaff_url_handle($encode_url), $content);

		}	
							
	} // end for each
	
	return $content;
	
}

//	Generate Referal Links
function envatoaff_url_handle($href){	
	return $href;	
}